#include <math.h>
#include "sgjbase.h"
#include "sgjmig.h"

void coe(float* a,float phi,float ep,float dl,float w_vp,float f,float kx)
{
float a0,a1,a2,a3,a4;
float fm1,epdl,sin2phi,sin4phi,sinphi,cosphi,cos2phi,b1,b2;

fm1=f-1;
epdl=ep-dl;
sin2phi=sin(2.0*phi);
cos2phi=cos(2.0*phi);
sin4phi=sin(4.0*phi);
sinphi=sin(phi);
cosphi=cos(phi);

a4=fm1+2.0*ep*fm1*pow(sinphi,2)-f/2.0*epdl*pow(sin2phi,2);
a3=(f*epdl*sin4phi-2.0*ep*fm1*sin2phi)*kx;
b2=f*epdl*pow(sin2phi,2)+2.0*fm1*(1+ep)-2.0*f*epdl*pow(cos2phi,2);
a2=b2*kx*kx+w_vp*w_vp*(2.0+2.0*ep*pow(sinphi,2)-f);
b1=2.0*ep*(-fm1)*sin2phi-f*epdl*sin4phi;
a1=b1*pow(kx,3)-2.0*ep*sin2phi*w_vp*w_vp*kx;
a0=(2.0+2.0*ep*pow(cosphi,2)-f)*w_vp*w_vp*kx*kx-pow(w_vp,4)-(-fm1*(1.0+2.0*ep*pow(cosphi,2))+f/2.0*epdl*pow(sin2phi,2))*pow(kx,4);
a[0]=a0; a[1]=a1; a[2]=a2; a[3]=a3; a[4]=a4;
}

void coe3d(float *a, float phi,float ep,float dl,float w_vp,float f, float kx,float ky)
{
   float a0,a1,a2,a3,a4;
   float sinphi,cosphi,fm1,epdl,sin2phi,cos2phi,sin4phi;
   float A,B,C,D,E,F;
   sinphi=-sin(phi); cosphi=cos(phi);
   fm1=f-1; epdl=ep-dl; sin2phi=-sin(2.0*phi); cos2phi=cos(2.0*phi); sin4phi=-sin(4.0*phi);
   //printf("sin=%f\n",sinphi);
   A=f-1;
   B=(f-1.0)*(1.0+2.0*ep);
   C=2.0*( (f-1.0)*(1.0+ep)-f*(ep-dl)    );
   D=(2.0+2.0*ep-f)*w_vp*w_vp;
   E=w_vp*w_vp*(2.0-f);
   F=-pow(w_vp,4);
   
   //printf("pow=%f,%f,%f,%f\n",pow(cosphi,4),A,B,C);   
 
   a4=A*pow(cosphi,4)+B*pow(sinphi,4)+C*pow(cosphi*sinphi,2);
   a3=(-A*4.0*pow(cosphi,3)*sinphi+4.0*B*cosphi*pow(sinphi,3)+2.0*C*(pow(cosphi,3)*sinphi-cosphi*pow(sinphi,3) ))*kx;
   a2=A*6.0*pow(cosphi*sinphi*kx,2)+B*( 6.0*pow(cosphi*sinphi*kx,2)+2.0*pow(sinphi*ky,2)  ) +
     C*( pow(cosphi,2)*(pow(cosphi*kx,2)+ky*ky)+ pow(sinphi,4)*kx*kx- 4.0*pow(cosphi*sinphi*kx,2))+D*pow(sinphi,2)+E*pow(cosphi,2);
   a1=A*(-4.0*cosphi*pow(sinphi*kx,3) )+B*4.0*(sinphi*pow(cosphi*kx,3)+cosphi*sinphi*kx*ky*ky) + 
     C*( 2.0*cosphi*pow(sinphi*kx,3) -2.0*cosphi*sinphi*kx*(pow(cosphi*kx,2)+ky*ky  )   ) +D*2.0*cosphi*sinphi*kx-2.0*E*cosphi*sinphi*kx;
   a0=A*pow(sinphi*kx,4)+B*( pow(cosphi*kx,4)+pow(ky,4)+2.0*pow(cosphi*kx*ky,2))+C*(pow(sinphi*kx,2)*(pow(cosphi*kx,2)+ky*ky  )   )+
      D*(pow(cosphi*kx,2)+ky*ky)+E*(pow(sinphi*kx,2)+ky*ky)+F;
   //printf("%f,%f,%f,%f,%f\n",a0,a1,a2,a3,a4);

/*   a4=fm1+2.0*ep*fm1*pow(sinphi,2)-f/2.0*epdl*pow(sin2phi,2);
   a3=(2.0*fm1*ep*sin2phi-f*epdl*sin4phi)*kx;
   a2=( 2*(f-1.0)*(1.0+ep)-f*epdl*(2.0*cos2phi*cos2phi-sin2phi*sin2phi ) )*kx*kx+ w_vp*w_vp*(2.0*ep*sinphi*sinphi+2.0-f)+
   2.0*ky*ky*( (f-1.0)*(1.0+ep)+(f-1.0)*ep*sinphi*sinphi-f*epdl*cosphi*cosphi);
   a1=pow(kx,3)*( 2.0*(f-1.0)*ep*sin2phi+f*epdl*sin4phi)+2.0*ep*pow(w_vp,2)*sin2phi*kx+ky*ky*2.0*sin2phi*kx*( (f-1.0)*ep+f*epdl);
   a0=pow(kx,4)*( fm1*(1.0+2.0*ep*cosphi*cosphi)-f*0.5*epdl*sin2phi*sin2phi  )+fm1*(1.0+2.0*ep)*pow(ky,4)+
   pow(kx*ky,2)*( fm1*(2.0*(1.0+ep)+2.0*ep*cosphi*cosphi)-2.0*f*epdl*sinphi*sinphi   )+
   pow(w_vp*kx,2)*(2.0-f+2.0*ep*cosphi*cosphi)-pow(w_vp,4)+pow(w_vp*ky,2)*(4.0+2.0*ep-2.0*f);
*/
//   printf("fromaa%f,%f,%f,%f,%f\n",a0,a1,a2,a3,a4);

   a[0]=a0; a[1]=a1; a[2]=a2; a[3]=a3; a[4]=a4;

}

__complex__ float kzani(float phi,float ep,float dl,float w_vp,float f,float kx)
{
    
  __complex__ float x1,z[4];
  float  a[5];
  int i,j;
  float kzsq;

  if (phi==0){
    coe(a,0.0,ep,dl,w_vp,1.0,kx);
    kzsq=-a[0]/a[2];
    if (kzsq >= 0 ) 
      x1=cmplx(sqrt(kzsq),0.0);
    else
      x1=cmplx(0.0, -sqrt(-kzsq));
  }
  else{
    coe(a,phi,ep,dl,w_vp,f,kx);
    //printf("2daaa=%f,%f,%f,%f,%f\n",a[4],a[3],a[2],a[1],a[0]);
    p4solver(a,z);
    x1=chooseproot(z);
  }
  return x1;
}

__complex__ float kzani3d(float phi,float ep,float dl,float w_vp,float f,float kx,float ky)
{
  __complex__ float x1,z[4];
  float  a[5];
  int i,j;
  float kzsq;

  if (phi==0){
    coe3d(a,0.0,ep,dl,w_vp,1.0,kx,ky);
    kzsq=-a[0]/a[2];
    if (kzsq >= 0 ) 
      x1=cmplx(sqrt(kzsq),0.0);
    else
      x1=cmplx(0.0, -sqrt(-kzsq));
  }
  else{
    coe3d(a,phi,ep,dl,w_vp,f,kx,ky);
    //printf("3daaa=%f,%f,%f,%f,%f\n",a[0],a[1],a[2],a[3],a[4]);
    p4solver(a,z);
    //printf("3dz%f,%f,%f,%f\n",__real__ z[0],__real__ z[1],__real__ z[2],__real__ z[3]);
    //printf("3dz%f,%f,%f,%f\n",__imag__ z[0],__imag__ z[1],__imag__ z[2],__imag__ z[3]);
    //printf("2dz(%f,%f),(%f,%f),(%f,%f),(%f,%f)\n",__real__ z[0],__imag__ z[0], __real__ z[1],__imag__ z[1],__real__ z[2],__imag__ z[2],__real__ z[3],__imag__ z[3]);
    x1=chooseproot(z);
  }
  return x1;
}



__complex__ float dkz(float phi,float ep,float dl,float w_vp,float f,float kx)
{
  __complex__ float  kz1,dkzp,kkz1;
  float kz,test;

  kz1=kzani(phi,ep,dl,w_vp,f,kx);
  //kkz1=kz1
  test=w_vp*w_vp-kx*kx;
  if (test >0.0)
    kz=sqrt(test);
  else
    kz=0.0;

  if ( fabs(aimag(kz1)) <0.0000001*fabs(real(kz1)) )
    dkzp=cmplx(fabs(real(kz1))-kz,0.0);    
    //dkzp=cmplx(fabs(real(kz1)),0.0);
  else
    dkzp=cmplx(0.0,-fabs(aimag(kz1)));

  return dkzp;
}

__complex__ float dkz3d(float phi,float ep,float dl,float w_vp,float f,float kx,float ky)
{
  __complex__ float  kz1,dkzp,kkz1;
  float kz,test;

  kz1=kzani3d(phi,ep,dl,w_vp,f,kx,ky);
  //kkz1=kz1
  test=w_vp*w_vp-(kx*kx+ky*ky);
  if (test >0.0){
    kz=sqrt(test);
  }
  else{
    kz=0.0;
  }
  if ( fabs(aimag(kz1)) <0.0000001*fabs(real(kz1)) )
    dkzp=cmplx(fabs(real(kz1))-kz,0.0);    
    //dkzp=cmplx(fabs(real(kz1)),0.0);
  else
    dkzp=cmplx(0.0,-fabs(aimag(kz1)));
  return dkzp;
}


__complex__ float dphase(float phi,float ep,float dl,float w_vp,float f,float kx,float dz)
{
  __complex__ float dphp,dkzp;
  float pshift;

  dkzp=dkz(phi,ep,dl,w_vp,f,kx);
  if (fabs(real(dkzp))*0.000001 > fabs(aimag(dkzp))){
    pshift=dz*real(dkzp);
    dphp=cmplx(cos(pshift),sin(pshift));
  }
  else{
    pshift=dz*(-fabs(aimag(dkzp)));
    dphp=cmplx(exp(pshift),0.0);
  }
  return dphp;
}

__complex__ float dphase3d(float phi,float ep,float dl,float w_vp,float f,float kx,float ky,float dz)
{
  __complex__ float dphp,dkzp;
  float pshift;

  dkzp=dkz3d(phi,ep,dl,w_vp,f,kx,ky);
  if (fabs(real(dkzp))*0.000001 > fabs(aimag(dkzp))){
    pshift=dz*real(dkzp);
    dphp=cmplx(cos(pshift),sin(pshift));
  }
  else{
    pshift=dz*(-fabs(aimag(dkzp)));
    dphp=cmplx(exp(pshift),0.0);
  }
  return dphp;
}




float gauweit(int weitm,int im){
  float gau;
  if (im <weitm-5)
    gau=1.0;
  else{
    
    if (im<weitm && im>=weitm-5){
      gau=(5.0-(im-weitm)-1.0)*0.1; 
    }
    else{
      if (im <weitm+4)
        gau=(5.0-(im-weitm)-1.0)*0.02;
      else
        gau=0.001;
    }
    gau=0.001;
  }
 
  return gau;
}

void dph(float phi,float ep,float dl,float w_vp,float f,float dkx,float dz,int m,__complex__ float *dpp,int weitm)
{
  // dpp(m)
  float kx;
  __complex__ float dkzp;
  float pshift;
  int im,nn;
  float cc,bb,dkzpweitm,dkzpweitm1;
 /* 
  for(im=0;im<m;im++){  //do im=1,m
    kx=im*dkx;
    dpp[im]=dphase(phi,ep,dl,w_vp,f,kx,dz);
  }
 */
  
  for (im=0;im<=weitm;im++){
    kx=im*dkx;
    dkzp=dkz(phi,ep,dl,w_vp,f,kx);
    pshift=dz*real(dkzp);
    dpp[im]=cmplx(cos(pshift),sin(pshift));
  }
  dkzpweitm=real( dkz(phi,ep,dl,w_vp,f,dkx*weitm));
  dkzpweitm1=real( dkz(phi,ep,dl,w_vp,f,dkx*(weitm-1)));
  bb=(dkzpweitm- dkzpweitm1)/dkx;
  cc=fabs(real(dkz(phi,ep,dl,w_vp,f,weitm*dkx)-dkz(phi,ep,dl,w_vp,f,0.0*dkx)));
  for (im=weitm+1;im<m;im++){
    kx=weitm*dkx;
    kx=(im-weitm)*dkx;
    dkzp=cc*sin(1.0/cc*bb*kx)+dkz(phi,ep,dl,w_vp,f,weitm*dkx);
    //dkzp=dkz(phi,ep,dl,w_vp,f,kx);
    pshift=dz*real(dkzp);
    dpp[im]=cmplx(cos(pshift),sin(pshift));
  }
  nn=weitm;
  nn=(m-weitm-2)/2;
  for(im=weitm;im<=weitm+2*nn;im++){
    if (im < m)
    dpp[im]*=0.8+0.1*( 1.0+cos((float)(im-weitm)*3.1415926/(float)(2*nn)  ));
  }
  //for(im=weitm+nn+nn+1;im<m;im++){
  //  dpp[im]*=0.9;
  //}
  
/*
  printf("ep=%f  dl=%f  w_vp=%f,f=%f, phi=%f\n",ep,dl,w_vp,f,phi);
  printf("dpppppppppppppp=%f\n",real(dpp[0]));
  printf("wwwwwwwwwwwwwwwwwwwwww=%d\n",weitm);
*/
  //weight(1:275)=1.0; weight(276:m)=0.001
  for (im=weitm+1; im <m; im++){ //do im=1,m  ?????????? wait
    //dpp[im]*=0.001;
    dpp[im]*=gauweit(weitm,im);
  }
}


void dph3d(float phi,float ep,float dl,float w_vp,float f,float dkx,float dky,float dz,int mx,int my,__complex__ float *dpp,float *weit)
{
  // dpp(m)
  float kx,ky;
  __complex__ float dkzp;
  float pshift;
  int imx,imy,weitmx,weitmy;
  float cc,bb,dkzpweitm,dkzpweitm1,nn,kx1,ky1,tmpr,scale,kx2,ky2,dkzp0;
  __complex__ float phab;
  for(imy=0;imy<my;imy++){ 
    ky=imy*dky;
    for(imx=0;imx<mx;imx++){  //do im=1,m
      kx=imx*dkx;
      dpp[i2(imy,imx,mx)]=dphase3d(phi,ep,dl,w_vp,f,kx,ky,dz);
    }
  }
  for(imx=0;imx<mx;imx++)
    if (weit[i2(0,imx,mx)]<0.8) break;
  for(imy=0;imy<my;imy++)
    if (weit[i2(imy,0,mx)]<0.8) break;
  weitmx=imx-1; weitmy=imy-1; 
  phab=dphase3d(phi,ep,dl,w_vp,f,0.0,weitmy*dky,dz);
  //printf("%d,%dweitm",weitmx,weitmy);
  //printf("%f,%f,%f\n",weitmy*dky,__real__ phab,__imag__ phab);
  //phab=dkz3d(phi,ep,dl,w_vp,f,weitmx*dkx,0.0);
  //printf ("x(%f,%f)\n",__real__ phab,__imag__ phab);
  //phab=dkz3d(phi,ep,dl,w_vp,f,0.0,weitmy*dky);
  //printf("y(%f,%f)\n",__real__ phab,__imag__ phab);
  
  for(imy=0;imy<my;imy++){
    ky=imy*dky;
    for(imx=0;imx<mx;imx++){
      kx=imx*dkx;
      tmpr=(float)(imy*imy)/(float)(weitmy*weitmy)+(float)(imx*imx)/(float)(weitmx*weitmx);
      nn=sqrt((float)(my*my)/(float)(weitmy*weitmy))-1.0;
      if (tmpr >=1){
        tmpr=sqrt(tmpr);
        kx1=kx/tmpr; ky1=ky/tmpr;
        kx2=kx1*(1.0-dkx/kx1); ky2=ky1*(1.0-dkx/kx1);
        if (imy==0){
        dkzpweitm=real(dkz3d(phi,ep,dl,w_vp,f,kx1,ky1));
        dkzpweitm1=real(dkz3d(phi,ep,dl,w_vp,f,kx2,ky2));
        dkzp0=real(dkz3d(phi,ep,dl,w_vp,f,0.0,0.0));
        bb=(dkzpweitm-dkzpweitm1);
        }
        dkzp0=real(dkz3d(phi,ep,dl,w_vp,f,0.0,0.0)); 
        dkzpweitm=real(dkz3d(phi,ep,dl,w_vp,f,kx1,ky1));
        cc=fabs(dkzpweitm-dkzp0);
        pshift=cc*sin(bb/cc*weitmx*(tmpr-1))+real(dkz3d(phi,ep,dl,w_vp,f,kx1,ky1));
        pshift=pshift*dz;
        //pshift=-3.1415926/6.0;
        phab=cmplx(cos(pshift),sin(pshift));
        dpp[i2(imy,imx,mx)]=phab;//dphase3d(phi,ep,dl,w_vp,f,kx1,ky1,dz)+phab;
        //if (imy==0) printf("%d,%f,%f\n",imx,bb,cc);
        //dpp[i2(imy,imx,mx)]=dphase3d(phi,ep,dl,w_vp,f,kx1,ky1,dz);
        scale=0.2+0.4*( 1.0+cos(3.1415926*(tmpr-1.0)/nn));
        if ((tmpr-1.0)>nn ) scale=0.2;
        dpp[i2(imy,imx,mx)]*=scale;
      }
    }
  }

  for(imy=0;imy<my;imy++)
   for(imx=0;imx<mx;imx++)
     dpp[i2(imy,imx,mx)]*=weit[i2(imy,imx,mx)]; 
   

}




int weit(float phi,float ep,float dl,float w_vp,float f,float dkx,int m)
{
  int weitm,im;
  __complex__ float  kz1,kzp1;
  float kx,weight;

  for (im=0; im <m; im++){
     kx=im*dkx;
     kz1=kzani(phi,ep,dl,w_vp,f,-kx);
     kzp1=kzani(phi,ep,dl,w_vp,f,kx);
     if ( fabs(aimag(kz1)) <0.0000001*fabs(real(kz1)) &&  fabs(aimag(kzp1)) <0.0000001*fabs(real(kzp1))){
       if (real(kz1) >w_vp*0.0 && real(kzp1) >w_vp*0.0  )
         weight=1.00;
       else
         weight=0.001;
     }
     else
       weight=0.001;
     if (weight!=1.0){
       weitm=im-2;
       break;
     }
  }
  if (im==m) weitm=m-2;
  if (phi==0.0) weitm-=2;
  weitm=weitm*(1-1.0/6.0);
  if (phi<=15.0/180.0*3.1415926 && weitm >1.8/3.0*m) weitm=1.8/3.0*m;
  return weitm;
}

void weit3d(float *weight,float phi,float ep,float dl,float w_vp,float f,float dkx,float dky,int mx,int my)
{
   int i_mx,i_my,im,ii_mx,ii_my,weitmy;
   __complex__ float  kz1,kzp1;
   float kx,ky;
   float tmpr;

   for (i_my=0;i_my<my;i_my++){
     ky=i_my*dky;
     for(i_mx=0;i_mx<mx;i_mx++){
       kx=i_mx*dkx;
       im=i_my*mx+i_mx;
       kz1= kzani3d(phi,ep,dl,w_vp,f,-kx,ky);
       kzp1=kzani3d(phi,ep,dl,w_vp,f,kx,ky);
       if ( fabs(aimag(kz1)) <0.0000001*fabs(real(kz1)) &&  fabs(aimag(kzp1)) <0.0000001*fabs(real(kzp1))){
         if (real(kz1) >w_vp*0.0 && real(kzp1) >w_vp*0.0  )
           weight[im]=1.00;
         else
           weight[im]=0.001;
       }
       else
         weight[im]=0.001; 
     }
   }
   for (i_my=0;i_my<my;i_my++){
     for(i_mx=0;i_mx<mx;i_mx++){
       im=i_my*mx+i_mx;
       if( 1.0!=weight[im]) break;
     }
     if ( i_mx <2){
       for (ii_mx=0;ii_mx<mx;ii_mx++)
         weight[i2(i_my,ii_mx,mx)]=0.001;
       break;
     }
     else{
       for (ii_mx=i_mx-2;ii_mx<mx;ii_mx++){
         weight[i2(i_my,ii_mx,mx)]=0.001;
       }
     }
   }
   printf("%d dddd\n",i_my);
   if(i_my>=2)
     for(ii_my=i_my;ii_my<my;ii_my++)
       for(ii_mx=0;ii_mx<mx;ii_mx++)
         weight[i2(ii_my,ii_mx,mx)]=0.001;
   for(i_mx=0;i_mx<mx;i_mx++){
     if (1.0!=weight[i_mx]) break;
   }
   printf("i_mx1=%d,i_my1=%d\n",i_mx,i_my);
   i_mx=i_mx*5.0/6.0; i_my=i_my*4.5/6.0;
   //i_my=i_mx;
   if (i_mx <2) i_mx=2; if(i_my<2) i_my=2;
   for (ii_my=0;ii_my<my;ii_my++){
     ky=ii_my*dky;
     for(ii_mx=0;ii_mx<mx;ii_mx++){
       im=ii_my*mx+ii_mx;
       kx=ii_mx*dkx;
       tmpr=(float)(ii_my*ii_my)/(float)(i_my*i_my)+(float)(ii_mx*ii_mx)/(float)(i_mx*i_mx);
       if (tmpr<1) weight[im]=1.0;
       else weight[im]=0.001;
     }
   }
   printf("i_mx=%d,i_my=%d\n",i_mx,i_my);
}

void phase_apro_matrix_cos(float *a,float dx,float dkx,int m,int n)
{
  // a(m,n)
  int i_m, i_n;
  float x,kx;

  for(i_m=0; i_m<m; i_m++){
    kx=i_m*dkx;
    for(i_n=0;i_n<n; i_n++){ 
      x=i_n*dx;
      a[i2(i_m,i_n,n)]=cos(x*kx);
    }
  }
} 

void phase_apro_matrix_cos3d(float *a,float dx,float dy,float dkx,float dky,int mx,int my,int nx,int ny)
{
  // a(m,n)
  int i_mx,i_my, i_nx,i_ny,i_m,i_n,n,m;
  float x,kx,y,ky;
  n=nx*ny; m=mx*my;
  for(i_my=0;i_my<my;i_my++){
   ky=i_my*dky;
   for(i_mx=0;i_mx<mx;i_mx++){
     kx=i_mx*dkx;
     i_m=i_my*mx+i_mx;
     for(i_ny=0;i_ny<ny;i_ny++){
       y=i_ny*dy;
       for(i_nx=0;i_nx<nx;i_nx++){
         x=i_nx*dx;
         i_n=i_ny*nx+i_nx;
         a[i2(i_m,i_n,n)]=cos(y*ky)*cos(x*kx);
       }
     }
   }
  }
} 


void phase_apro_matrix_sin(float *a,float dx,float dkx,int m,int n)
{  // a(m-1,n-1)

  int i_m,i_n;
  float x,kx;

  for (i_m=0; i_m < m-1; i_m++){
    kx=(i_m+1)*dkx;
    for(i_n=0; i_n <n-1; i_n++){
      x=(i_n+1)*dx;
      a[i2(i_m,i_n,n-1)]=sin(x*kx); // ??????????????/
    }
  }
}


void phase_apro_matrix_sin3d(float *a,float dx,float dy,float dkx,float dky,int mx,int my,int nx,int ny)
{  // a(m-1,n-1)
  int i_m,i_n,i_mx,i_my,i_nx,i_ny,m,n;
  float x,kx,y,ky;
  m=(mx-1)*my; n=(nx-1)*ny;
  for(i_my=0;i_my<my;i_my++){
    ky=i_my*dky; 
    for(i_mx=0;i_mx<mx-1;i_mx++){
      kx=(i_mx+1)*dkx;
      i_m=i_my*(mx-1)+i_mx;
      for(i_ny=0;i_ny<ny;i_ny++){
        y=i_ny*dy;
        for(i_nx=0;i_nx<nx-1;i_nx++){
          x=(i_nx+1)*dx;
          i_n=i_ny*(nx-1)+i_nx;
          a[i2(i_m,i_n,n)]=cos(y*ky)*sin(x*kx);

        }
      } 
    }
  }


}

void convlv_coe(int m,int n,__complex__ float *conap,__complex__ float *conam,__complex__ float *dpc,__complex__ float *dps, float *qc,float *rc,float *qs,float *rs){ // conap(n) conam(n) dpc(m) dps(m) qc(m,n) rc(n,n) qs(m-1,n-1) rs(n-1,n-1)
__complex__ float dpp1,dpp2;
__complex__ float *conas;
int sing,im,i;
conas=(__complex__ float *)malloc((n-1)*sizeof(__complex__ float));
for(i=0;i<m;i++){
  dpp1=(dpc[i]+dps[i])/2.0;
  dpp2=(dpc[i]-dps[i])/2.0;
  dpc[i]=dpp1;
  if (i > 0 ) dps[i-1]=dpp2;
}
/*
for (i=0;i<m;i++)
   printf("1dps[%d]=(%f,%f)\n",i+1,__real__ dps[i],__imag__ dps[i]);
for(i=0;i<n;i++)
    printf("rs(6,%d)=%f\n",i+1,rs[i2(5,i,n-1)]);
*/
qrcon(qc,rc,dpc,conap,m,n);
qrcon(qs,rs,dps,conas,m-1,n-1);
for(i=1;i<n;i++){
  conam[i]=0.5*conap[i]-0.5*(cmplx(0.0,1.0))*conas[i-1];
  conap[i]=0.5*conap[i]+0.5*(cmplx(0.0,1.0))*conas[i-1];
}
//for (i=0;i<n;i++)
//   printf("1conap[%d]=(%f,%f)\n",i+1,__real__ conap[i],__imag__ conap[i]);
free(conas);
}


void convlv_coe3d(int mx,int my,int nx,int ny,__complex__ float *conap,__complex__ float *conam,__complex__ float *dpc,__complex__ float *dps, float *qc,float *rc,float *qs,float *rs){ // conap(n) conam(n) dpc(m) dps(m) qc(m,n) rc(n,n) qs(m-1,n-1) rs(n-1,n-1)
__complex__ float dpp1,dpp2;
__complex__ float *conas;
int sing,im,i,m,n,mm1,nm1,imx,imy,imm,inx,iny,inm,in;
m=mx*my; n=nx*ny; mm1=my*(mx-1); nm1=ny*(nx-1);
//conas=(__complex__ float *)malloc((nm1)*sizeof(__complex__ float));
conas=allocatec(nm1);
for(imy=0;imy<my;imy++){
  for(imx=0;imx<mx;imx++){
    im=imy*mx+imx;
    dpp1=(dpc[im]+dps[im])/2.0;
    dpp2=(dpc[im]-dps[im])/2.0;
    dpc[im]=dpp1;
    if (imx>0){
      imm=imy*(mx-1)+imx-1;
      dps[imm]=dpp2;
    }  
  }
}
qrcon(qc,rc,dpc,conap,m,n);
qrcon(qs,rs,dps,conas,mm1,nm1);
//for(i=0;i<n;i++)
//      printf("i=%d,(%f,%f)   ",i,__real__ conas[i],__imag__ conas[i]);
//for(i=0;i<n;i++)
//        printf("i=%d,%f   ",i,rs[i]);
//printf("\n");
for(iny=0;iny<ny;iny++){
  for(inx=1;inx<nx;inx++){
    in=iny*nx+inx;
    inm=iny*(nx-1)+inx-1;
    conam[in]=0.5*conap[in]-0.5*(cmplx(0.0,1.0))*conas[inm];
    conap[in]=0.5*conap[in]+0.5*(cmplx(0.0,1.0))*conas[inm];
  }
}

free(conas);
}





void ani_equation_con(float dx,float dkx,int m,int n,int weitm,float *qc,float *rc,float *qs,float *rs)
{  // qc(m,n),rc(n,n),qs(m-1,n-1),rs(n-1,n-1)
//real :: weight(:)
  float *ma,*q,*tmpd;
  int  sing,im,in;

  ma=allocatef(m*n);
  q=allocatef(m*m);
  tmpd=allocatef(n);
  //allocate(ma(m,n),q(m,m),tmpd(n))

  phase_apro_matrix_cos(ma,dx,dkx,m,n);
  for(im=weitm+1;im<m; im++)
    for(in=0;in<n;in++)
      //ma[i2(im,in,n)]*=0.001;
      ma[i2(im,in,n)]*=gauweit(weitm,im);
  //do im=1,m
  //   ma(im,:)=ma(im,:)*weight(im)
  //end do

  qrdcmp(ma,m,n,tmpd,sing);
  qrdpost(ma,m,n,tmpd,q,rc);
  for(im=0;im<m;im++)
    for(in=0;in<n;in++)
      qc[i2(im,in,n)]=q[i2(im,in,m)];//qc=q(1:m,1:n)

  phase_apro_matrix_sin(ma,dx,dkx,m,n);
  for(im=weitm;im<m-1; im++)
    for(in=0;in<n-1;in++)
      //ma[i2(im,in,n-1)]*=0.001; 
      ma[i2(im,in,n-1)]*=gauweit(weitm,im);
  //do im=1,m-1
  //  ma(im,:)=ma(im,:)*weight(im+1) //! ????????????????????????????????
  //end do
  qrdcmp(ma,m-1,n-1,tmpd,sing);
  qrdpost(ma,m-1,n-1,tmpd,q,rs);
  for(im=0;im<m-1;im++)
    for(in=0;in<n-1;in++)
      qs[i2(im,in,n-1)]=q[i2(im,in,m-1)];  //qs=q(1:m-1,1:n-1)
  free(ma);free(q);free(tmpd);
}



void ani_equation_con3d(float dx,float dy,float dkx,float dky,int mx,int my,int nx,int ny,float *weight,float *qc,float *rc,float *qs,float *rs)
{  // qc(m,n),rc(n,n),qs(m-1,n-1),rs(n-1,n-1)
//real :: weight(:)
  float *ma,*q,*tmpd;
  int  sing,im,in,m,n,mm1,nm1,imx,imy,iwm;
  m=mx*my; n=nx*ny;
  ma=allocatef(m*n);
  q=allocatef(m*m);
  tmpd=allocatef(n);
  //allocate(ma(m,n),q(m,m),tmpd(n))
  printf("1\n");
  phase_apro_matrix_cos3d(ma,dx,dy,dkx,dky,mx,my,nx,ny);
  for(im=0;im<m; im++)
    for(in=0;in<n;in++)
      ma[i2(im,in,n)]*=weight[im];
   printf("2\n");
  qrdcmp(ma,m,n,tmpd,sing);
   printf("3\n");
  qrdpost(ma,m,n,tmpd,q,rc);
  printf("5\n");
  for(im=0;im<m;im++)
    for(in=0;in<n;in++)
      qc[i2(im,in,n)]=q[i2(im,in,m)];//qc=q(1:m,1:n)
  phase_apro_matrix_sin3d(ma,dx,dy,dkx,dky,mx,my,nx,ny);
   printf("4\n");
  mm1=my*(mx-1); nm1=ny*(nx-1);
  for(imy=0;imy<my;imy++){
    for(imx=0;imx<mx-1;imx++){
      im=imy*(mx-1)+imx;
      iwm=imy*mx+imx+1;
      for(in=0;in<nm1;in++)
        ma[i2(im,in,nm1)]*=weight[iwm];
    }
  }
  //do im=1,m-1
  //  ma(im,:)=ma(im,:)*weight(im+1) //! ????????????????????????????????
  //end do
  qrdcmp(ma,mm1,nm1,tmpd,sing);
 /*
  printf("\n****************\n");
  for(in=0;in<n;in++)
     printf("***%f",tmpd[in]);
  printf("\n*************\n");
  */
  qrdpost(ma,mm1,nm1,tmpd,q,rs);
  for(im=0;im<mm1;im++)
    for(in=0;in<nm1;in++)
      qs[i2(im,in,nm1)]=q[i2(im,in,mm1)];  //qs=q(1:m-1,1:n-1)
  free(ma);free(q);free(tmpd);
}





void ani_init(float dx,float dkx,int m,int n,int nweit,int *weitm,float *qc_table, float *rc_table, float *qs_table,float *rs_table)
{  // weitm(nweit),qc_table(nweit,m,n),rc_table(nweit,n,n),qs_table(nweit,m-1,n-1),rs_table(nweit,n-1,n-1)
  int im,in,iweit;
  int nqc[2],nrc[2],nqs[2],nrs[2];
  float *qc,*rc,*qs,*rs;
  d3(m,n,nqc); d3(n,n,nrc); d3(m-1,n-1,nqs); d3(n-1,n-1,nrs); 
  qc=allocatef(m*n); rc=allocatef(n*n); qs=allocatef((m-1)*(n-1)); rs=allocatef((n-1)*(n-1));
  // qc(m,n),rc(n,n),qs(m-1,n-1),rs(n-1,n-1)

  for(iweit=0;iweit<nweit; iweit++){
     //printf("iweit=%d  nweit=%d   \n",iweit,nweit);
     ani_equation_con(dx,dkx,m,n,weitm[iweit],qc,rc,qs,rs);
     for(im=0;im<m;im++)
       for(in=0;in<n;in++)
          qc_table[i3(iweit,im,in,nqc)]=qc[i2(im,in,n)]; //qc_table(iweit,:,:)=qc(:,:)
     for(im=0;im<n;im++)
       for(in=0;in<n;in++)
          rc_table[i3(iweit,im,in,nrc)]=rc[i2(im,in,n)];  //rc_table(iweit,:,:)=rc(:,:)
     for(im=0;im<m-1;im++)
       for(in=0;in<n-1;in++)
          qs_table[i3(iweit,im,in,nqs)]=qs[i2(im,in,n-1)];    //qs_table(iweit,:,:)=qs(:,:)
     for(im=0;im<n-1;im++)
       for(in=0;in<n-1;in++)
          rs_table[i3(iweit,im,in,nrs)]=rs[i2(im,in,n-1)];     //rs_table(iweit,:,:)=rs(:,:)
  }
  free(qc);free(rc);free(qs);free(rs);
}

void explicit_table3d(__complex__ float *conapp,__complex__ float *conapm,
                      float phi,float f,float dx,float dy,float dkx,float dky,float dz,int mx,int my,int nx,int ny,
                      float ep,float dl,float w_vp,float *weight,float *qc,float *rc,float *qs,float *rs)
{
  int im,in,imx,imy,inx,iny,m,n,mm1,nm1;
  //float *qc,*rc,*qs,*rs,*weight;
  __complex__ float *dppc,*dpps;
  m=my*mx; n=ny*nx; mm1=my*(mx-1); nm1=ny*(nx-1);
  //qc=allocatef(m*n); rc=allocatef(n*n); qs=allocatef(mm1*nm1); rs=allocatef(nm1*nm1); weight=allocatef(m);
  dppc=allocatec(m); dpps=allocatec(m);
  printf("bbbbbbbbbbbbb\n");
  //weit3d(weight,phi,ep,dl,w_vp,f,dkx,dky,mx,my);
  dph3d(phi,ep,dl,w_vp,f,dkx,dky,dz,mx,my,dppc,weight);
  dph3d(phi,ep,dl,w_vp,f,-dkx,dky,dz,mx,my,dpps,weight);
  printf("aaaaaaaaaaa\n");
  //ani_equation_con3d(dx,dy,dkx,dky,mx,my,nx,ny,weight,qc,rc,qs,rs);
  printf("cccccccccccccc\n");
  convlv_coe3d(mx,my,nx,ny,conapp,conapm,dppc,dpps, qc,rc,qs,rs);
  printf("dddddddddddd \n");  

  //free(qc); free(rc); free(qs); free(rs); free(weight);
  free(dppc); free(dpps); 
  
}


void explicit_table2d(__complex__ float *conapp,__complex__ float *conapm,
                      float phi,float f,float dx,float dkx,float dz,int mx,int nx,
                      float ep,float dl,float w_vp)
{
  int im,in,imx,imy,inx,iny,m,n,mm1,nm1;
  float *qc,*rc,*qs,*rs,*weight;
  int my,ny; 
  float dy,dky;
  my=1; ny=1; dy=dx; dky=dkx;
  __complex__ float *dppc,*dpps;
  m=my*mx; n=ny*nx; mm1=my*(mx-1); nm1=ny*(nx-1);
  qc=allocatef(m*n); rc=allocatef(n*n); qs=allocatef(mm1*nm1); rs=allocatef(nm1*nm1); weight=allocatef(m);
  dppc=allocatec(m); dpps=allocatec(m);
  printf("bbbbbbbbbbbbb\n");
  weit3d(weight,phi,ep,dl,w_vp,f,dkx,dky,mx,my);
  dph3d(phi,ep,dl,w_vp,f,dkx,dky,dz,mx,my,dppc,weight);
  dph3d(phi,ep,dl,w_vp,f,-dkx,dky,dz,mx,my,dpps,weight);
  
  printf("aaaaaaaaaaa\n");
  ani_equation_con3d(dx,dy,dkx,dky,mx,my,nx,ny,weight,qc,rc,qs,rs);
  printf("cccccccccccccc\n");
  convlv_coe3d(mx,my,nx,ny,conapp,conapm,dppc,dpps, qc,rc,qs,rs);
  printf("dddddddddddd \n");  
  free(qc); free(rc); free(qs); free(rs); free(dppc); free(dpps); free(weight);
  
}




void explicit_table(__complex__ float *contablepp,__complex__ float *contablepm,
                    float phi,float f,float dx,float dkx,float dz, int m,int n,
                    float o_ep,float d_ep,int n_ep,float o_dl,float d_dl,int n_dl,float o_w_vp,float d_w_vp,int n_w_vp)
{  //contablepp(n_w_vp,n_ep,n_dl,n), contablepm(n_w_vp,n_ep,n_dl,n)
__complex__ float *conapp,*conapm,*dppc,*dpps;
float *qc_table,*rc_table,*qs_table,*rs_table;
float *qc,*rc,*qs,*rs;
float w_vp,ep,dl;
int *weitm,nweit,theweitm,iweit;
int im,in,i_w_vp,i_ep,i_dl;
int nqc[2],nrc[2],nqs[2],nrs[2],nconp[3];
int i;
printf("begin 11111\n");
d3(m,n,nqc); d3(n,n,nrc); d3(m-1,n-1,nqs); d3(n-1,n-1,nrs); d4(n_ep,n_dl,n,nconp);
printf("begin 22222\n");
weitm=allocatei(m);
printf("begin 33333\n");
nweit=weitmlist(weitm,phi,dkx,f,m,o_ep,d_ep,n_ep,o_dl,d_dl,n_dl,o_w_vp,d_w_vp,n_w_vp);
printf("begin 44444\n");
printf("mmmm=%d,nweit=%d\n",m,nweit);
conapp=allocatec(n); conapm=allocatec(n); dppc=allocatec(m); dpps=allocatec(m);
qc_table=allocatef(nweit*m*n); 
rc_table=allocatef(nweit*n*n); 
qs_table=allocatef(nweit*(m-1)*(n-1) ); rs_table=allocatef(nweit*(n-1)*(n-1));
qc=allocatef(m*n); rc=allocatef(n*n); qs=allocatef((m-1)*(n-1)); rs=allocatef((n-1)*(n-1));

//write(*,*) "begin ani_init"
ani_init(dx,dkx,m,n,nweit,weitm,qc_table,rc_table,qs_table,rs_table);
//write(*,*) "end ani_init"
printf("aaaaaaaaaaaa1\n");
//n_w_vp=1; n_ep=1; n_dl=1;
for(i_w_vp=0;i_w_vp<n_w_vp; i_w_vp++){  //do i_w_vp=1,n_w_vp
  w_vp=o_w_vp+i_w_vp*d_w_vp;
  for(i_ep=0;i_ep<n_ep;i_ep++){//do i_ep=1,n_ep
    ep=i_ep*d_ep+o_ep;
    for(i_dl=0;i_dl<n_dl;i_dl++){ //do i_dl=1,n_dl
      dl=i_dl*d_dl+o_dl;
      theweitm=weit(phi,ep,dl,w_vp,f,dkx,m); 
      if (0==theweitm) theweitm=1;
      dph(phi,ep,dl,w_vp,f,dkx,dz,m,dppc,theweitm);  //call dph(phi,ep,dl,w_vp,f,0.0,dkx,dz,m,dppc,dpmc)
      /* 
      if (i_ep==0 && i_dl==0 && i_w_vp==0 ){
         for(i=0;i<m;i++)
             printf("con[%d]=%f ",i,__real__ dppc[i] );
      }
      */
      dph(phi,ep,dl,w_vp,f,-dkx,dz,m,dpps,theweitm); //call dph(phi,ep,dl,w_vp,f,0.0,-dkx,dz,m,dpps,dpms) 

      //!      call ani_equation_con(dx,dkx,m,n,weightp)
      for(iweit=0;iweit<nweit;iweit++){
        if(theweitm==weitm[iweit]) break;
      }
      for(im=0;im<m;im++)
        for(in=0;in<n;in++)
          qc[i2(im,in,n)]=qc_table[i3(iweit,im,in,nqc)];     //qc(:,:)=qc_table(iweit,:,:);
      for(im=0;im<n;im++)
        for(in=0;in<n;in++)
          rc[i2(im,in,n)]=rc_table[i3(iweit,im,in,nrc)];    //  rc(:,:)=rc_table(iweit,:,:);
      for(im=0;im<m-1;im++)
        for(in=0;in<n-1;in++)
          qs[i2(im,in,n-1)]=qs_table[i3(iweit,im,in,nqs)];     //qs(:,:)=qs_table(iweit,:,:);
      for(im=0;im<n-1;im++)
        for(in=0;in<n-1;in++)
          rs[i2(im,in,n-1)]=rs_table[i3(iweit,im,in,nrs)];   //rs(:,:)=rs_table(iweit,:,:);
      convlv_coe(m,n,conapp,conapm,dppc,dpps,qc,rc,qs,rs);
     /* 
      if (i_ep==0 && i_dl==0 && i_w_vp==0 ){
         for(i=0;i<n;i++)
           printf("con[%d]=(%f,%f) ",i,__real__ conapp[i],__imag__ conapp[i] ); 
         printf("\n");
      }
      */
      
      for(in=0;in<n;in++){
        contablepp[i4(i_w_vp,i_ep,i_dl,in,nconp)]=conapp[in];  //contablepp(:,i_dl,i_ep,i_w_vp)=conapp(:)
        contablepm[i4(i_w_vp,i_ep,i_dl,in,nconp)]=conapm[in];  //contablepm(:,i_dl,i_ep,i_w_vp)=conapm(:)
      }
    }
  }
}
//write(*,*) "end concoe"
free(conapp); free(conapm); 
free(dppc); free(dpps);
free(qc_table); free(rc_table); 
free(qs_table); free(rs_table);
free(qc);free(rc);free(qs);free(rs);
free(weitm);
}

int weitmlist(int *weitm,float phi,float dkx,float f,int m,
             float o_ep,float d_ep,int n_ep,float o_dl,float d_dl,int n_dl,float o_w_vp,float d_w_vp,int n_w_vp)
{
  int i_w_vp, i_ep,i_dl;
  float w_vp,ep,dl;
  int theweitm;
  int *weitm_tmp;
  int nweit,iweit;
  /*
  weitm_tmp=allocatei(m);  
  printf("weit1\n");
  nweit=0;
  for(i_w_vp=0;i_w_vp<n_w_vp; i_w_vp++){
    w_vp=o_w_vp+i_w_vp*d_w_vp;
    for(i_ep=0;i_ep<n_ep; i_ep++){
      ep=o_ep+i_ep*d_ep;
      for(i_dl=0;i_dl<n_dl; i_dl++){
        dl=o_dl+d_dl*i_dl;
        theweitm=weit(phi,ep,dl,w_vp,f,dkx,m);
        for(iweit=0;iweit<nweit; iweit++){
          if (theweitm==weitm_tmp[iweit]) break;
        }
        if (iweit==nweit){
           weitm_tmp[nweit]=theweitm;
           nweit++;
        }
      }
    }
  }
  printf("weit2\n");
  for(iweit=0; iweit<nweit; iweit++)
     weitm[iweit]=weitm_tmp[iweit];
  free(weitm_tmp);
  */
  nweit=m*(1-1.0/6.0);
  for(iweit=0;iweit<nweit;iweit++)
    weitm[iweit]=iweit+1;
  return nweit;
}
