#include <sepcube.h>
#include <sgjbase.h>
#include <sgjmig.h>

// shot_data_init has to be run before all subroutine in this file
struct shot_plane_par_type shot_plane_init(struct shot_data_par_type data_par)
{
//type(sep3d):: plane_data
  struct shot_plane_par_type plane_par;
  filehead plane_data;
  float opx,dpx,opy,dpy;
  int npx,npy;
  float x_min,y_min,x_max,y_max,tmp_x_min,tmp_y_min;
  int plane_nx,plane_ny,tmp_plane_nx,tmp_plane_ny;
  float plane_osx,plane_dsx,plane_osy,plane_dsy;
  int plane_nsx,plane_nsy;
  if (0==getch("opx","f",&opx) ) opx=0.0;
  if (0==getch("dpx","f",&dpx) ) dpx=1.0;
  if (0==getch("npx","d",&npx) ) npx=30;
  if (0==getch("opy","f",&opy) ) opy=0.0;
  if (0==getch("dpy","f",&dpy) ) dpy=1.0;
  if (0==getch("npy","d",&npy) ) npy=1;

  plane_osx=data_par.osx; plane_dsx=data_par.dsx; plane_nsx=data_par.nsx;
  plane_osy=data_par.osy; plane_dsy=data_par.dsy; plane_nsy=data_par.nsy;
  tmp_x_min=MIN(data_par.osx,data_par.osx+data_par.dsx*(data_par.nsx-1))+MIN(data_par.ohx+data_par.dhx*(data_par.nhx-1),data_par.ohx);
  tmp_y_min=MIN(data_par.osy,data_par.osy+data_par.dsy*(data_par.nsy-1))+MIN(data_par.ohy+data_par.dhy*(data_par.nhy-1),data_par.ohy);
  if (0==getch("plane_x_min","f",&x_min)) x_min=tmp_x_min;
  if (0==getch("plane_y_min","f",&y_min)) x_min=tmp_y_min;
  x_max=MAX(data_par.osx,data_par.osx+(data_par.nsx-1)*data_par.dsx)+MAX(data_par.ohx,data_par.ohx+(data_par.nhx-1)*data_par.dhx);
  y_max=max(data_par.osy,data_par.osy+(data_par.nsy-1)*data_par.dsy)+MAX(data_par.ohy,data_par.ohy+(data_par.nhy-1)*data_par.dhy);
  tmp_plane_nx=(x_max-tmp_x_min)/fabs(data_par.dhx)+1;
  tmp_plane_ny=(y_max-tmp_y_min)/fabs(data_par.dhy)+1;
  if (0==getch("plane_nx","d",&plane_nx) ) plane_nx=tmp_plane_nx;
  if (0==getch("plane_ny","d",&plane_ny) ) plane_ny=tmp_plane_ny;

  plane_data.ndims=5;
  plane_data.o[0]=x_min;       plane_data.d[0]=fabs(data_par.dhx);plane_data.n[0]=plane_nx;
  plane_data.o[1]=y_min;       plane_data.d[1]=fabs(data_par.dhy);plane_data.n[1]=plane_ny;
  plane_data.o[2]=data_par.ow; plane_data.d[2]=data_par.dw;      plane_data.n[2]=data_par.nw;
  plane_data.o[3]=opx;         plane_data.d[3]=dpx;              plane_data.n[3]=npx;
  plane_data.o[4]=opy;         plane_data.d[4]=dpy;              plane_data.n[4]=npy;
  stat=file_open_ouput_c("Plane",plane_data);

  auxputch ("plane_os_x","f",plane_osx,"Plane");auxputch ("plane_ds_x","f",plane_dsx,"Plane");
  auxputch ("plane_ns_x","i",plane_nsx,"Plane");auxputch ("plane_os_y","f",plane_osy,"Plane");
  auxputch ("plane_ds_y","f",plane_dsy,"Plane");auxputch ("plane_ns_y","i",plane_nsy,"Plane");
  plane_par.osx=plane_osx; plane_par.dsx=plane_dsx; plane_par.nsx=plane_nsx;
  plane_par.osy=plane_osy; plane_par.dsy=plane_dsy; plane_par.nsy=plane_nsy;
  plane_par.nx=plane_nx;   plane_par.dx=fabs(data_par.dhx);  plane_par.ox=x_min;
  plane_par.ny=plane_ny;  plane_par.dy=fabs(data_par.dhy);  plane_par.oy=y_min;
  plane_par.ow=data_par.ow;plane_par.dw= data_par.dw; plane_par.nw=data_par.nw;
  plane_par.npx=npx;       plane_par.dpx=dpx;       plane_par.opx=opx;
  plane_par.npy=npy;       plane_par.dpy=dpy;       plane_par.opy=opy;
  plane_par.nhx=data_par.nhx; plane_par.dhx=data_par.dhx; plane_par.ohx=data_par.dhx;
  plane_par.nhy=data_par.nhy; plane_par.dhy=data_par.dhy; plane_par.ohy=data_par.dhy;

return plane_par;
}

void shot_plane_write(struct shot_plane_par_type plane_par){
  float px,py;
  int ipx,ipy;
  __complex__ float  *wld=allocatec(plane_par.nx*plane_par.ny*plane_par.nw);
  int blocksize=plane_par.nx*plane_par.ny*plane_par.nw*8;
  for(ipy=0;ipy<plane_par.npy;ipy++){
    py=(float)(ipy)*dpy+opy;
    for(ipx=0;ipx<plane_par.npx;ipx++){
      px=(float)(ipx)*dpx+opx;
      vector_value_c(wld,cmplx(0.0,0.0),plane_nx*plane_ny*data_par.nw);   //wld=0.0
      plane_transfer(px,py,wld,plane_par);
      if (srite("Plane",wld,blocksize)!=blocksize )seperr("err write");
    }
  }
  free(wld);
}

void shot_plane_transfer(float px,float py,__complex__ float *wld,struct shot_plane_par_type plane_par){

float  min_x,min_y;
int nx,ny;
float plane_osx,plane_dsx,plane_osy,plane_dsy;
int plane_nsx,plane_nsy;

__complex__ float *tmp_wld;
__complex__ phaseshift;
float x_dt,y_dt,t_y,t_x;
int blocksize,i_block;
int plane_isy,plane_isx,isx,isy,iw,i_ox,i_oy;
int i_ox_min, i_ox_max,i_oy_min,i_oy_max,i_x,i_y;
float plane_sy,shot_oy,plane_sx,shot_ox,w;
int nwld[2],ntmpwld[2];

min_x=plane_par.ox; min_y=plane_par.oy; nx=plane_par.nx; ny=plane_par.ny;
plane_osx=plane_par.osx; plane_dsx=plane_par.dsx; plane_osy=plane_par.osy; plane_dsy=plane_par.dsy;
plane_nsx=plane_par.nsx; plane_nsy=plane_par.nsy;
x_dt=plane_dsx*px;
y_dt=plane_dsy*py;

tmp_wld=allocatec(plane_par.nhx*plane_par.nhy*plane_par.nw);
d3(plane_par.ny,plane_par.nx,nwld); d3(plane_par.nhy,plane_par.nhx,ntmpwld);

blocksize=8*plane_par.nhx*plane_par.nhy*plane_par.nw;
for (plane_isy=0;plane_isy<plane_nsy;plane_isy++){
  t_y=(float)(plane_isy)*y_dt;
  plane_sy=(float)(plane_isy)*plane_dsy+plane_osy;
  isy=(plane_sy-plane_par.osy)/plane_par.dsy;  ! index in shot gather data
  shot_oy=plane_sy+plane_par.ohy;
  i_oy=(shot_oy-min_y)/plane_par.dhy;    ! index in plane wave
  for(plane_isx=0;plane_isx<plane_nsx; plane_isx++){
    plane_sx=(float)(plane_isx)*plane_dsx+plane_osx; 
    isx=(plane_sx-plane_par.osx)/plane_par.dsx;
    t_x=plane_isx*x_dt;
    shot_ox=plane_sx+plane_par.ohx;
    i_ox=(shot_ox-min_x)/fabs(plane_par.dhx);
    i_block=isy*plane_par.nsx+isx;
    if ( sseek_block("Data",i_block,blocksize,0) !=i_block) seperr("plane source data seek wrong");
    if ( sreed("Data",tmp_wld,blocksize )!= blocksize) seperr("plane source data read wrong");
    i_ox_min=MIN(i_ox,i_ox+SGN(plane_par.dhx)*(plane_par.nhx-1));
    i_ox_max=max(i_ox,i_ox+SGN(plane_par.dhx)*(plane_par.nhx-1));
    i_oy_min=min(i_oy,i_oy+SGN(plane_par.dhy)*(plane_par.nhy-1));
    i_oy_max=max(i_oy,i_oy+SGN(plane_par.dhy)*(plane_par.nhy-1));
    for(iw=0;iw<plane_par.nw;iw++){
      w=(float)(iw)*plane_par.dw+plane_par.ow;
      phaseshift=cmplx(cos(w*t_x),sin(w*t_x));
      if (plane_par.dhx >0) {
        for(i_y=0;i_y<plane_par.nhy;i_y++)
           for(i_x=0;i_x<plane_par.nhx;i_x++)
             wld[i3(iw,i_oy_min+i_y,i_ox_min+i_x,nwld)]+=tmp_wld[i3(iw,i_y,i_x,ntmpwld)]*phaseshift;
      }
      else{
        for(i_y=0;i_y<plane_par.nhy; i_y++)
          for(i_x=0;i_x<plane_par.nhx; i_x++)
             wld[i3(iw,i_oy+i_y,i_ox-ix,nwld)]+=tmp_wld[i3(iw,i_y,i_x,ntmpwld)]*phaseshift;
      }
    }
  }
}
free(tmp_wld);

}
