program fftwt
use sep3d_struct_mod
use sep
implicit none
real :: f_min,f_max,pi,fw,dw
integer :: iw_min,iw_max,nw
integer :: nt_pad
integer :: is,ihx
integer :: blocksize_in, blocksize_out
real, allocatable :: shot(:)
complex,allocatable :: shot_w(:),trace(:)
integer :: iw
real    :: w
type(sep3d) :: data_in, data_out
integer,external :: sreed,srite 

call initpar()

call from_param("f_min",f_min,5.0)
call from_param("f_max",f_max,50.0)
pi=3.1415926

call init_sep3d("in",data_in,"INPUT")
! data: t,hx,sx
call from_param("nt_pad",nt_pad,data_in%n(1))
dw=2.0*pi/((data_in%n(1)+nt_pad)*data_in%d(1))
write(0,*) 'dw',dw,'fmin',f_min,'fmax',f_max
fw=2.0*pi*f_min
iw_min=2.0*pi*f_min/dw
iw_max=2.0*pi*f_max/dw
nw=iw_max-iw_min+1
write(0,*) nw


call init_sep3d(data_out,"OUTPUT","COMPLEX","REGULAR",ctag="out")
!call init_sep3d(data_out,"OUTPUT","FLOAT","REGULAR",ctag="out")
call axis_allocate(data_out,1)
data_out%o(1)=fw
data_out%d(1)=dw
data_out%n(1)=nw
!data_out%o(1)=data_in%o(1)
!data_out%d(1)=data_in%d(1)
!data_out%n(1)=data_in%n(1)
call sep3d_set_sep3d(data_out)
call sep3d_write_description("out",data_out)

!call auxpar('waht','f',0.002,"out")
call auxputch ("waht","f",0.002,"out")
write(*,*) "test"

allocate( shot(data_in%n(1)) )
allocate( shot_w(data_out%n(1)) )
allocate(trace(data_in%n(1)+nt_pad) )

blocksize_in=data_in%n(1)*4
blocksize_out=data_out%n(1)*8
shot=0.0
if (sreed("in",shot,blocksize_in)/=blocksize_in ) call seperr("wrong read")
trace=0.0
trace(1:data_in%n(1))=cmplx(shot(:),0)
call CFFT1DE(trace,data_in%n(1)+nt_pad,+1)

do iw=1,data_in%n(1)+nt_pad
   w=(iw-1)*dw
   trace(iw)=trace(iw)*cmplx(cos(-w*0.048),sin(-w*0.048))
end do
!call CFFT1DE(trace,data_in%n(1)+nt_pad,-1)

shot_w(:)=trace(iw_min:iw_max)
if(srite("out",shot_w,blocksize_out)/=blocksize_out)call seperr("wrong rite")

!if (srite("out",real(trace(1:data_in%n(1))),blocksize_in)/=blocksize_in) call seperr("wrong rite")
end program fftwt
