program surfacefft
use sep3d_struct_mod
use sep
implicit none
real :: f_min,f_max,pi,fw,dw
integer :: iw_min,iw_max,nw
integer :: nt_pad
integer :: is,ihx
integer :: blocksize_in, blocksize_out
real, allocatable :: shot(:,:)
complex,allocatable :: shot_w(:,:),trace(:)
type(sep3d) :: data_in, data_out
integer,external :: sreed,srite 

call initpar()

call from_param("f_min",f_min,5.0)
call from_param("f_max",f_max,50.0)
pi=3.1415926

call init_sep3d("in",data_in,"INPUT")
! data: t,hx,sx
call from_param("nt_pad",nt_pad,data_in%n(1))
dw=2.0*pi/((data_in%n(1)+nt_pad)*data_in%d(1))
write(0,*) 'dw',dw,'fmin',f_min,'fmax',f_max
fw=2.0*pi*f_min
iw_min=2.0*pi*f_min/dw
iw_max=2.0*pi*f_max/dw
nw=iw_max-iw_min+1
write(0,*) nw
write(*,*)"test"

call init_sep3d(data_out,"OUTPUT","COMPLEX","REGULAR",ctag="out")
call axis_allocate(data_out,5)
data_out%o(1)=data_in%o(2)
data_out%d(1)=data_in%d(2)
data_out%n(1)=data_in%n(2)
data_out%o(4)=data_in%o(3)
data_out%d(4)=data_in%d(3)
data_out%n(4)=data_in%n(3)
data_out%o(3)=fw
data_out%d(3)=dw
data_out%n(3)=nw
data_out%o(2)=0
data_out%d(2)=data_in%d(2)
data_out%n(2)=1
data_out%o(5)=0
data_out%n(5)=1
data_out%d(5)=data_out%d(4)
call sep3d_set_sep3d(data_out)
call sep3d_write_description("out",data_out)

allocate( shot(data_in%n(1),data_in%n(2)) )
allocate( shot_w(data_out%n(1),data_out%n(3)) )
allocate(trace(data_in%n(1)+nt_pad) )

blocksize_in=data_in%n(1)*data_in%n(2)*4
blocksize_out=data_out%n(1)*data_out%n(3)*8
write(*,*)"test1"
do is=1,data_in%n(3)
  shot=0.0
  if (sreed("in",shot,blocksize_in)/=blocksize_in ) call seperr("wrong read")
  do ihx=1,data_in%n(2)
    trace=0.0
    trace(1:data_in%n(1))=cmplx(shot(:,ihx),0)
    call CFFT1DE(trace,data_in%n(1)+nt_pad,+1)
    shot_w(ihx,:)=trace(iw_min:iw_max)
  end do
  if(srite("out",shot_w,blocksize_out)/=blocksize_out)call seperr("wrong rite")
end do


end program surfacefft
